/* 
 * CS:APP Data Lab 
 * 
 * <Please put your name and userid here>
 * 
 * bits.c - Source file with your solutions to the Lab.
 *          This is the file you will hand in to your instructor.
 *
 * WARNING: Do not include the <stdio.h> header; it confuses the dlc
 * compiler. You can still use printf for debugging without including
 * <stdio.h>, although you might get a compiler warning. In general,
 * it's not good practice to ignore compiler warnings, but in this
 * case it's OK.  
 */

#if 0
/*
 * Instructions to Students:
 *
 * STEP 1: Read the following instructions carefully.
 */

You will provide your solution to the Data Lab by
editing the collection of functions in this source file.

INTEGER CODING RULES:
 
  Replace the "return" statement in each function with one
  or more lines of C code that implements the function. Your code 
  must conform to the following style:
 
  int Funct(arg1, arg2, ...) {
      /* brief description of how your implementation works */
      int var1 = Expr1;
      ...
      int varM = ExprM;

      varJ = ExprJ;
      ...
      varN = ExprN;
      return ExprR;
  }

  Each "Expr" is an expression using ONLY the following:
  1. Integer constants 0 through 255 (0xFF), inclusive. You are
      not allowed to use big constants such as 0xffffffff.
  2. Function arguments and local variables (no global variables).
  3. Unary integer operations ! ~
  4. Binary integer operations & ^ | + << >>
    
  Some of the problems restrict the set of allowed operators even further.
  Each "Expr" may consist of multiple operators. You are not restricted to
  one operator per line.

  You are expressly forbidden to:
  1. Use any control constructs such as if, do, while, for, switch, etc.
  2. Define or use any macros.
  3. Define any additional functions in this file.
  4. Call any functions.
  5. Use any other operations, such as &&, ||, -, or ?:
  6. Use any form of casting.
  7. Use any data type other than int.  This implies that you
     cannot use arrays, structs, or unions.

 
  You may assume that your machine:
  1. Uses 2s complement, 32-bit representations of integers.
  2. Performs right shifts arithmetically.
  3. Has unpredictable behavior when shifting if the shift amount
     is less than 0 or greater than 31.


EXAMPLES OF ACCEPTABLE CODING STYLE:
  /*
   * pow2plus1 - returns 2^x + 1, where 0 <= x <= 31
   */
  int pow2plus1(int x) {
     /* exploit ability of shifts to compute powers of 2 */
     return (1 << x) + 1;
  }

  /*
   * pow2plus4 - returns 2^x + 4, where 0 <= x <= 31
   */
  int pow2plus4(int x) {
     /* exploit ability of shifts to compute powers of 2 */
     int result = (1 << x);
     result += 4;
     return result;
  }

FLOATING POINT CODING RULES

For the problems that require you to implement floating-point operations,
the coding rules are less strict.  You are allowed to use looping and
conditional control.  You are allowed to use both ints and unsigneds.
You can use arbitrary integer and unsigned constants. You can use any arithmetic,
logical, or comparison operations on int or unsigned data.

You are expressly forbidden to:
  1. Define or use any macros.
  2. Define any additional functions in this file.
  3. Call any functions.
  4. Use any form of casting.
  5. Use any data type other than int or unsigned.  This means that you
     cannot use arrays, structs, or unions.
  6. Use any floating point data types, operations, or constants.


NOTES:
  1. Use the dlc (data lab checker) compiler (described in the handout) to 
     check the legality of your solutions.
  2. Each function has a maximum number of operations (integer, logical,
     or comparison) that you are allowed to use for your implementation
     of the function.  The max operator count is checked by dlc.
     Note that assignment ('=') is not counted; you may use as many of
     these as you want without penalty.
  3. Use the btest test harness to check your functions for correctness.
  4. Use the BDD checker to formally verify your functions
  5. The maximum number of ops for each function is given in the
     header comment for each function. If there are any inconsistencies 
     between the maximum ops in the writeup and in this file, consider
     this file the authoritative source.

/*
 * STEP 2: Modify the following functions according the coding rules.
 * 
 *   IMPORTANT. TO AVOID GRADING SURPRISES:
 *   1. Use the dlc compiler to check that your solutions conform
 *      to the coding rules.
 *   2. Use the BDD checker to formally verify that your solutions produce 
 *      the correct answers.
 */


#endif
/* Copyright (C) 1991-2020 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   <https://www.gnu.org/licenses/>.  */
/* This header is separate from features.h so that the compiler can
   include it implicitly at the start of every compilation.  It must
   not itself include <features.h> or any other header that includes
   <features.h> because the implicit include comes before any feature
   test macros that may be defined in a source file before it first
   explicitly includes a system header.  GCC knows the name of this
   header in order to preinclude it.  */
/* glibc's intent is to support the IEC 559 math functionality, real
   and complex.  If the GCC (4.9 and later) predefined macros
   specifying compiler intent are available, use them to determine
   whether the overall intent is to support these features; otherwise,
   presume an older compiler has intent to support these features and
   define these macros by default.  */
/* wchar_t uses Unicode 10.0.0.  Version 10.0 of the Unicode Standard is
   synchronized with ISO/IEC 10646:2017, fifth edition, plus
   the following additions from Amendment 1 to the fifth edition:
   - 56 emoji characters
   - 285 hentaigana
   - 3 additional Zanabazar Square characters */

int onebitParity(int x) {

    x ^= x << 16;
    x ^= x << 8;
    x ^= x << 4;
    x ^= x << 2;
    x ^= x << 1;

    return ((x >> 31) & 0x1);

}

int checkSubstraction(int x, int y) {

    // 2's complement
    int result = x + ( 1 + (~y));

    int sign_x = (x >> 31) & 0x1;
    int sign_y = (y >> 31) & 0x1;
    int sign_result = (result >> 31) & 0x1;

    int xy_Diff = (sign_x ^ sign_y) & 0x1;
    int xresult_Diff = (sign_x ^ sign_result) & 0x1;

    int Overflow = xy_Diff & xresult_Diff;
    int notOverflow = (~Overflow) & 0x1;

    return notOverflow;

}


int twoscom2SignedVal(int x) {

    // if (-) sign sign=0xffffffff, else sign 0x0
    int sign = x >> 31;

    // if (-) sign real_sign=0x1, else sign 0x0
    int real_sign = sign & (0x1);

    // if (-) sign not_unchanged = ~x, else not_unchaanged = x
    int not_unchanged = x^sign;

    int absvalue = not_unchanged + real_sign;

    int result = (sign << 31) | absvalue;

    return result;
}

int nibbleReverse(int x) {

    int f = 0xf;
    int ff = 0xff;
    int mask1 = (ff<<8) |ff;
    int mask2 = (ff<<16) | ff;
    int f0f = (f<<8) | f;
    int mask3 = (f0f<<16) | f0f;

    int inverse_mask2 = ~mask2;
    int inverse_mask3 = ~mask3;

    x = ((x&mask1)<<16) | ((x>>16)&mask1);
    x = ((x<<8)&inverse_mask2) | ((x>>8)&mask2);
    x = ((x<<4)&inverse_mask3) | ((x>>4)&mask3);

    return x;
}

int bitFilter(int input, int highbit, int lowbit) {


    int ff = 0xff;
    int one = 0x1;
    int ffff = (ff<<8) | ff;
    int ffffffff = (ffff<<16) | ffff;

    int temp1 = ffffffff<<lowbit;
    int temp2 = one<<highbit;
    
    int mask;
    int result;

    temp2 |= temp2>>16;
    temp2 |= temp2>>8;
    temp2 |= temp2>>4;
    temp2 |= temp2>>2;
    temp2 |= temp2>>1;

    mask = temp1 & temp2;
    result = input & mask;

    return result;

}

int addAndDivideBy4(int x, int y) {

    int result = x + y;

    // sign : (-) sign : 0xffffffff, (+) sign : 0x00000000
    int sign_x = x >> 31;
    int sign_y = y >> 31;
    int sign_result = result >> 31;

    int resultDiby4_pos = (~sign_result) & (result>>2);
    int three = 0x3;
    // 3=2^2-1(for devide negative number by 4)
    int resultDiby4_neg = (sign_result) & ((result+three)>>2);
    int resultDiby4 = resultDiby4_pos | resultDiby4_neg;

    int xy_Same = sign_x ^ (~sign_y);
    int xresult_Diff = sign_x ^ sign_result;

    // if overflow occur : Overflow = 0xffffffff, else overflow = 0x00000000
    int Overflow = xy_Same & xresult_Diff;

    int rValue_Over = Overflow & x;
    int rValue_notOver = (~Overflow) & resultDiby4;
    int rValue = rValue_Over | rValue_notOver;

    return rValue;
}

 int numZerosFirst(int x) {


     int doubleFive = 0x55;
     int doubleThree = 0x33;

     // mask 1: 0x55555555
     // mask 2: 0x33333333
     // mask 3: 0x0f0f0f0f
     // mask 4: 0x00ff00ff
     // mask 5: 0x0000ffff

     int ff = 0xff;
     int f=0xf;
     
     int mask1;
     int mask2;
     int mask3;
     int mask4;
     int mask5;
     
     int rValue;
     
     mask1 = (doubleFive<<8) | doubleFive;
     mask1 += (mask1<<16);
     mask2 = (doubleThree<<8) | doubleThree;
     mask2 += (mask2<<16);
     mask3 = (f<<8) | f;
     mask3 = (mask3<<16) | mask3;

     mask4 = (ff<<16) | ff;
     mask5 = (ff<<8) | ff;
     
     rValue;
     
     x|=x>>16;
     x|=x>>8;
     x|=x>>4;
     x|=x>>2;
     x|=x>>1;

     x = (x & mask1) + ((x >> 1) & mask1);
     x = (x & mask2) + ((x >> 2) & mask2);
     x = (x & mask3) + ((x >> 4) & mask3);
     x = (x & mask4) + ((x >> 8) & mask4);
     x = (x & mask5) + ((x >> 16) & mask5);

     rValue = 32 + ((~x) + 1);

     return rValue;
 }
 

unsigned absFloat(unsigned uf) {

    // 1 : sign , 2 ~ 9 : exponent, 10 ~ 32 : fraction
    // NaN : exponent = 11111111, fraction =/= 00...00

    unsigned checkSign = 0x80000000u;
    unsigned currSign = checkSign & uf;
    unsigned absValue = uf - currSign;
    
    unsigned checkExponent = 0x00000100u;
    unsigned exponentPlusone = (absValue>>23)+1;
    unsigned fractionPart = absValue<<9;
    
    //check NaN
    if((checkExponent==exponentPlusone) && (fractionPart !=0x0)) return uf;
    return absValue;
    
}
 
int castFloat2Int(unsigned uf) {

    int rValue_overflow = 0x80000000u;
    unsigned checkSign = 0x80000000u;
    unsigned checkExp = 0x7F800000u;
    unsigned checkFrac = 0x007fffffu;

    int currSign = uf & checkSign;
    int currExp = uf & checkExp;
    int currFrac = uf & checkFrac;
    
    int Bias = 127;
    int currFracplusOne;
    
    int absValue = 0x00000000;
    
    currFracplusOne = 0x00800000 | currFrac;

    if (checkExp == currExp) return rValue_overflow;

    currExp = (currExp >> 23) - Bias;

    if(uf == 0xCF000000u) return  rValue_overflow;

    // calculate avsValue, if exp >= 31 return 0x80000000u
    if (currExp<0) absValue = 0x0;
    
    else if (currExp < 24) absValue = currFracplusOne >> (23 - currExp);
    else if (currExp < 31) absValue = currFracplusOne << (currExp -23);
    else return rValue_overflow;

    if (checkSign == currSign) return ((~absValue) + 1);
    return absValue;
}
 
 int compareFloat(unsigned uf, unsigned ug) {

    int TRUE = 0x1;
    int FALSE = 0x0;

    unsigned checkSign = 0x80000000u;
    unsigned checkExp = 0x7F800000u;
    unsigned checkFrac = 0x007fffffu;

    unsigned ufSign = uf & checkSign;
    unsigned ufExp = uf & checkExp;
    unsigned ufFrac = uf & checkFrac;

    unsigned ugSign = ug & checkSign;
    unsigned ugExp = ug & checkExp;
    unsigned ugFrac = ug & checkFrac;
    
    int result;
    
    if((uf==0x80000000)&&(ug==0x0)) return FALSE;

    // f= NaN
    if ((ufExp==checkExp) && (ufFrac!=0x0)) return FALSE;
    // g= NaN
    if ((ugExp==checkExp) && (ugFrac!=0x0)) return FALSE;

    // case1 : ufSign (+), ugSign (-)
    // case2 : ufSign (-), ugSign (+)
    if (ufSign<ugSign)  return FALSE;
    else if (ufSign>ugSign)  return TRUE;

    // To consider with comparing negative number
    result = FALSE;
    if(uf==ug) return FALSE;

    if(ufExp<ugExp) result=TRUE;
    else if(ufExp>ugExp) result = FALSE;
    else {
        if(ufFrac<ugFrac) result=TRUE;
        else if(ufFrac>ugFrac) result=FALSE;
    }

    // Both two number are negative - > temp = 1 - temp
    if(ufSign == checkSign) result = 1 - result;
    
    return result;

}


